Commit fea739a7 authored by Ivanq's avatar Ivanq

Merge branch 'initbare'

parents 1989f554 cd592742
......@@ -8,10 +8,6 @@
"description": "Default Git Center Repo",
"favicon": "img/logo-red.svg",
"files": {
"content.json-default": {
"sha512": "079103ca57004699f00cf57cdc949b1ee9e298bdeaddda6745032bcf9af332e3",
"size": 6565
},
"data-default/users/content.json-default": {
"sha512": "091029acc8d6ba0f1c8c19dbb0df97ec810b454d690668bbb844c334fae396c4",
"size": 541
......@@ -27,92 +23,16 @@
"js/ZeroFrame.js": {
"sha512": "672291eadcac614188b41e2df665cacf0c3b1b1d775cbf8291abab2d9e669f9d",
"size": 2502
},
"repo.git-default/HEAD": {
"sha512": "76b199f1bffdc6d21547895431b0f85f3857df400225cbd1ae55e7ded09786a8",
"size": 23
},
"repo.git-default/config": {
"sha512": "6b53072edfe2b5837f91eec3f8dbc5a08f41719986c12876a23eb7ec20b6674a",
"size": 151
},
"repo.git-default/description": {
"sha512": "f7e152f75b124c3e1c5d12f00427729d9eec4e2c1bf70d7606440a6600d00336",
"size": 73
},
"repo.git-default/hooks/applypatch-msg.sample": {
"sha512": "536cce804d84e25813993efdd240537b52d00ce9cdcecf1982f85096d56a5212",
"size": 478
},
"repo.git-default/hooks/commit-msg.sample": {
"sha512": "d6bb7fa747f4625adf1877f546565cbe812ca7dd4168f7e9068e6732555d8737",
"size": 896
},
"repo.git-default/hooks/post-receive": {
"sha512": "f75819ab8e020ae5ac0165bc19d07990362571e1c6da54438b08132a8c6c8f48",
"size": 2015
},
"repo.git-default/hooks/post-update.sample": {
"sha512": "473ad124642571656276bf83b9ff63ab1804d3c23a5bdae52391c6f70a894849",
"size": 189
},
"repo.git-default/hooks/pre-applypatch.sample": {
"sha512": "cb78aa7e9b9c146e5db65d86dd83f04e2b6942a06fab50c704a0fd900683f3b6",
"size": 424
},
"repo.git-default/hooks/pre-commit.sample": {
"sha512": "4a7ac2ed2ffe50d2a997c3477b5855c3d19423c295a82f7d660be3418217a183",
"size": 1642
},
"repo.git-default/hooks/pre-push.sample": {
"sha512": "37cd20a090494acb16c2255fe93dadeb409f2553afddc409dad5b5e99c9f5612",
"size": 1348
},
"repo.git-default/hooks/pre-rebase.sample": {
"sha512": "de9bdf513f383b3215e467c025ca851a0f2661b91811bfd441486b678e4d45e4",
"size": 4951
},
"repo.git-default/hooks/pre-receive": {
"sha512": "7e4bc3042655351c9a097d41a6bd68d306ac39786d2b631173e4f067c11f366f",
"size": 865
},
"repo.git-default/hooks/pre-receive.sample": {
"sha512": "ee08c11fab7e896b2e09c241954ba7640338b12c75cd8040daf053c31b2f2223",
"size": 544
},
"repo.git-default/hooks/prepare-commit-msg.sample": {
"sha512": "fbf15f12136a413dd590e57392e6122714d67456beed50d9ef285e40076a138a",
"size": 1239
},
"repo.git-default/hooks/update.sample": {
"sha512": "759abd33e5d1dda9b3e3d3116c47b23f616320d70cd66d567b1c4eeefeb6d785",
"size": 3610
},
"repo.git-default/info/exclude": {
"sha512": "9828c6ecdf91bf117416e17f4ee9caee2e1e37b6fb00b9ff04035ace17a3089b",
"size": 240
},
"repo.git-default/objects/4b/825dc642cb6eb9a060e54bf8d69288fbee4904": {
"sha512": "20f2df3641c9830fce6af6af53f9f0ef89a59c3eb224feda882f1aa0aa79c852",
"size": 15
},
"repo.git-default/objects/96/b2b8eb0cc004663a987424c32630ca27b94857": {
"sha512": "a12982f1b9f0b8c089cfc8680e4d28b55da37909e6ded3b2f0c3d2579b3b145b",
"size": 126
},
"repo.git-default/refs/heads/master": {
"sha512": "f90da8aba34ef5b244b5432feae0adde74e9a771c9cfbc8cc890e0681adb7fa8",
"size": 42
}
},
"ignore": "",
"inner_path": "content.json",
"merged_type": "GitCenter",
"modified": 1506454966,
"modified": 1506873683,
"postmessage_nonce_security": true,
"signers_sign": "HIbkXHjK35NbjH6FiPXQ6yWz6FagbYVIRVKKA+XdtHUwbgSErgTMH5KoEiJSm3UbygccjfySXI/qIH6C4I+xLAc=",
"signs": {
"1RepoXU8bQE9m7ssNwL4nnxBnZVejHCc6": "GypVMEP8gL5H4nyYJocLpLI8v0OZ/35onJeHlhKSnqyDT8GM7Ib+i7QBocST1YqH2joRyAUMHEdw/2bl/TqxP8s="
"1RepoXU8bQE9m7ssNwL4nnxBnZVejHCc6": "HB2KACIS6D7DqE6yEa6CyrdX31sJHbhnX/BEyVAjdRSkJOv3s2KGrxjC9X0xse158wu6DzyXwoCkzh2F5mr1MZU="
},
"signs_required": 1,
"title": "Default Git Center Repo",
......
{
"address": "1RepoXU8bQE9m7ssNwL4nnxBnZVejHCc6",
"address_index": 80074647,
"background-color": "#FFF",
"clone_root": "template-new",
"cloneable": true,
"cloned_from": "1HeLLo4uzjaLetFx6NH3PMwFP3qbRbTf3D",
"description": "My new Git Center repository",
"favicon": "img/logo-red.svg",
"files": {
"data-default/users/content.json-default": {
"sha512": "091029acc8d6ba0f1c8c19dbb0df97ec810b454d690668bbb844c334fae396c4",
"size": 541
},
"img/logo-red.svg": {
"sha512": "9f5481798d939ab8018a4e8a8baebf094e070eebd41b3ec5dd305e55430df5e3",
"size": 888
},
"index.html": {
"sha512": "f05f08df94e7bd7f1638cbdd5cdc5e56a4f769a38e88fb599e519cf29ac4ff9c",
"size": 1064
},
"js/ZeroFrame.js": {
"sha512": "672291eadcac614188b41e2df665cacf0c3b1b1d775cbf8291abab2d9e669f9d",
"size": 2502
},
"repo.git-default/HEAD": {
"sha512": "76b199f1bffdc6d21547895431b0f85f3857df400225cbd1ae55e7ded09786a8",
"size": 23
},
"repo.git-default/config": {
"sha512": "192677c0b786738f8345637660febaa5fded96187ada4d0851eeae29421b66ce",
"size": 110
},
"repo.git-default/description": {
"sha512": "f7e152f75b124c3e1c5d12f00427729d9eec4e2c1bf70d7606440a6600d00336",
"size": 73
},
"repo.git-default/hooks/applypatch-msg.sample": {
"sha512": "536cce804d84e25813993efdd240537b52d00ce9cdcecf1982f85096d56a5212",
"size": 478
},
"repo.git-default/hooks/commit-msg.sample": {
"sha512": "d6bb7fa747f4625adf1877f546565cbe812ca7dd4168f7e9068e6732555d8737",
"size": 896
},
"repo.git-default/hooks/post-update.sample": {
"sha512": "473ad124642571656276bf83b9ff63ab1804d3c23a5bdae52391c6f70a894849",
"size": 189
},
"repo.git-default/hooks/pre-applypatch.sample": {
"sha512": "cb78aa7e9b9c146e5db65d86dd83f04e2b6942a06fab50c704a0fd900683f3b6",
"size": 424
},
"repo.git-default/hooks/pre-commit.sample": {
"sha512": "4a7ac2ed2ffe50d2a997c3477b5855c3d19423c295a82f7d660be3418217a183",
"size": 1642
},
"repo.git-default/hooks/pre-push.sample": {
"sha512": "37cd20a090494acb16c2255fe93dadeb409f2553afddc409dad5b5e99c9f5612",
"size": 1348
},
"repo.git-default/hooks/pre-rebase.sample": {
"sha512": "de9bdf513f383b3215e467c025ca851a0f2661b91811bfd441486b678e4d45e4",
"size": 4951
},
"repo.git-default/hooks/pre-receive.sample": {
"sha512": "ee08c11fab7e896b2e09c241954ba7640338b12c75cd8040daf053c31b2f2223",
"size": 544
},
"repo.git-default/hooks/prepare-commit-msg.sample": {
"sha512": "fbf15f12136a413dd590e57392e6122714d67456beed50d9ef285e40076a138a",
"size": 1239
},
"repo.git-default/hooks/update.sample": {
"sha512": "759abd33e5d1dda9b3e3d3116c47b23f616320d70cd66d567b1c4eeefeb6d785",
"size": 3610
},
"repo.git-default/info/exclude": {
"sha512": "9828c6ecdf91bf117416e17f4ee9caee2e1e37b6fb00b9ff04035ace17a3089b",
"size": 240
},
"repo.git-default/objects/4b/825dc642cb6eb9a060e54bf8d69288fbee4904": {
"sha512": "20f2df3641c9830fce6af6af53f9f0ef89a59c3eb224feda882f1aa0aa79c852",
"size": 15
},
"repo.git-default/objects/96/b2b8eb0cc004663a987424c32630ca27b94857": {
"sha512": "a12982f1b9f0b8c089cfc8680e4d28b55da37909e6ded3b2f0c3d2579b3b145b",
"size": 126
},
"repo.git-default/refs/heads/master": {
"sha512": "f90da8aba34ef5b244b5432feae0adde74e9a771c9cfbc8cc890e0681adb7fa8",
"size": 42
},
"repo.git/HEAD": {
"sha512": "76b199f1bffdc6d21547895431b0f85f3857df400225cbd1ae55e7ded09786a8",
"size": 23
},
"repo.git/config": {
"sha512": "192677c0b786738f8345637660febaa5fded96187ada4d0851eeae29421b66ce",
"size": 110
},
"repo.git/description": {
"sha512": "f7e152f75b124c3e1c5d12f00427729d9eec4e2c1bf70d7606440a6600d00336",
"size": 73
},
"repo.git/hooks/applypatch-msg.sample": {
"sha512": "536cce804d84e25813993efdd240537b52d00ce9cdcecf1982f85096d56a5212",
"size": 478
},
"repo.git/hooks/commit-msg.sample": {
"sha512": "d6bb7fa747f4625adf1877f546565cbe812ca7dd4168f7e9068e6732555d8737",
"size": 896
},
"repo.git/hooks/post-update.sample": {
"sha512": "473ad124642571656276bf83b9ff63ab1804d3c23a5bdae52391c6f70a894849",
"size": 189
},
"repo.git/hooks/pre-applypatch.sample": {
"sha512": "cb78aa7e9b9c146e5db65d86dd83f04e2b6942a06fab50c704a0fd900683f3b6",
"size": 424
},
"repo.git/hooks/pre-commit.sample": {
"sha512": "4a7ac2ed2ffe50d2a997c3477b5855c3d19423c295a82f7d660be3418217a183",
"size": 1642
},
"repo.git/hooks/pre-push.sample": {
"sha512": "37cd20a090494acb16c2255fe93dadeb409f2553afddc409dad5b5e99c9f5612",
"size": 1348
},
"repo.git/hooks/pre-rebase.sample": {
"sha512": "de9bdf513f383b3215e467c025ca851a0f2661b91811bfd441486b678e4d45e4",
"size": 4951
},
"repo.git/hooks/pre-receive.sample": {
"sha512": "ee08c11fab7e896b2e09c241954ba7640338b12c75cd8040daf053c31b2f2223",
"size": 544
},
"repo.git/hooks/prepare-commit-msg.sample": {
"sha512": "fbf15f12136a413dd590e57392e6122714d67456beed50d9ef285e40076a138a",
"size": 1239
},
"repo.git/hooks/update.sample": {
"sha512": "759abd33e5d1dda9b3e3d3116c47b23f616320d70cd66d567b1c4eeefeb6d785",
"size": 3610
},
"repo.git/info/exclude": {
"sha512": "9828c6ecdf91bf117416e17f4ee9caee2e1e37b6fb00b9ff04035ace17a3089b",
"size": 240
},
"repo.git/objects/4b/825dc642cb6eb9a060e54bf8d69288fbee4904": {
"sha512": "20f2df3641c9830fce6af6af53f9f0ef89a59c3eb224feda882f1aa0aa79c852",
"size": 15
},
"repo.git/objects/96/b2b8eb0cc004663a987424c32630ca27b94857": {
"sha512": "a12982f1b9f0b8c089cfc8680e4d28b55da37909e6ded3b2f0c3d2579b3b145b",
"size": 126
},
"repo.git/refs/heads/master": {
"sha512": "f90da8aba34ef5b244b5432feae0adde74e9a771c9cfbc8cc890e0681adb7fa8",
"size": 42
}
},
"ignore": "data/.*",
"includes": {
"data/users/content.json": {
"signers": [],
"signers_required": 1
}
},
"inner_path": "content.json",
"merged_type": "GitCenter",
"modified": 1505931588,
"postmessage_nonce_security": true,
"signers_sign": "HIbkXHjK35NbjH6FiPXQ6yWz6FagbYVIRVKKA+XdtHUwbgSErgTMH5KoEiJSm3UbygccjfySXI/qIH6C4I+xLAc=",
"signs": {
"1RepoXU8bQE9m7ssNwL4nnxBnZVejHCc6": "HKCaPyof2vlzqlC6uCvkdF4rQOwvoip2Pvj2keAgQ9jBI5ejFrS4OgQS0rYz4uQP80YzQaGCn85L+tcAaUN9LxQ="
},
"installed": false,
"signs_required": 1,
"title": " new repository",
"translate": ["js/all.js"],
"zeronet_version": "0.5.7"
}
\ No newline at end of file
[core]
repositoryformatversion = 0
filemode = false
bare = true
symlinks = false
ignorecase = true
[receive]
advertisePushOptions = true
Unnamed repository; edit this file 'description' to name the repository.
#!/bin/sh
#
# An example hook script to check the commit log message taken by
# applypatch from an e-mail message.
#
# The hook should exit with non-zero status after issuing an
# appropriate message if it wants to stop the commit. The hook is
# allowed to edit the commit message file.
#
# To enable this hook, rename this file to "applypatch-msg".
. git-sh-setup
commitmsg="$(git rev-parse --git-path hooks/commit-msg)"
test -x "$commitmsg" && exec "$commitmsg" ${1+"[email protected]"}
:
#!/bin/sh
#
# An example hook script to check the commit log message.
# Called by "git commit" with one argument, the name of the file
# that has the commit message. The hook should exit with non-zero
# status after issuing an appropriate message if it wants to stop the
# commit. The hook is allowed to edit the commit message file.
#
# To enable this hook, rename this file to "commit-msg".
# Uncomment the below to add a Signed-off-by line to the message.
# Doing this in a hook is a bad idea in general, but the prepare-commit-msg
# hook is more suited to it.
#
# SOB=$(git var GIT_AUTHOR_IDENT | sed -n 's/^\(.*>\).*$/Signed-off-by: \1/p')
# grep -qs "^$SOB" "$1" || echo "$SOB" >> "$1"
# This example catches duplicate Signed-off-by lines.
test "" = "$(grep '^Signed-off-by: ' "$1" |
sort | uniq -c | sed -e '/^[ ]*1[ ]/d')" || {
echo >&2 Duplicate Signed-off-by lines.
exit 1
}
#!/bin/bash
sign=1
publish=1
if test -n "$GIT_PUSH_OPTION_COUNT"
then
i=0
while test "$i" -lt "$GIT_PUSH_OPTION_COUNT"
do
eval "value=\$GIT_PUSH_OPTION_$i"
case "$value" in
no-sign)
sign=0
;;
no-publish)
publish=0
;;
esac
i=$((i + 1))
done
fi
if [ $sign -eq 0 ]; then
echo "no-sign rejects signing, rejecting."
exit 0
fi
################################################################################
zeronet_home=`git config --get zeronet.home`
if [ -z "$zeronet_home" ]; then
echo "zeronet.home not set, rejecting to sign."
echo "Run 'git config --global zeronet.home path_to_zeronet'"
exit 0
fi
site=`basename $(realpath "$GIT_DIR/..")`
python_path=`command -v python`
if [ -z "$python_path" ]; then
python_path=`command -v python2`
fi
if [ -z "$python_path" ]; then
echo "Python not installed, rejecting to sign."
exit 0
fi
################################################################################
echo "Retrieving data directory..."
data_dir=`"$python_path" "$zeronet_home/zeronet.py" --silent getConfig | "$python_path" -c "import sys, json; config = json.load(sys.stdin); print config['data_dir']"`
privatekey=`cat "$data_dir/users.json" | "$python_path" -c "import sys, json; users = json.load(sys.stdin); print users[users.keys()[0]]['certs']['zeroid.bit']['auth_privatekey']"`
if [ $? -ne 0 ]; then
echo "Failed to get signing key, rejecting to sign."
exit 0
fi
echo "Signing..."
"$python_path" "$zeronet_home/zeronet.py" siteSign "$site" "$privatekey" 2>&1 | grep "Private key invalid" >/dev/null 2>&1
if [ $? -eq 0 ]; then
echo "Failed to sign, invalid private key. Probably you are not a maintainer."
exit 0
fi
if [ $publish -eq 0 ]; then
echo "no-publish rejects publishing, rejecting."
echo "Signed successfully"
exit 0
fi
echo "Publishing..."
"$python_path" "$zeronet_home/zeronet.py" sitePublish "$site" >/dev/null 2>&1
echo "Signed & published successfully"
\ No newline at end of file
#!/bin/sh
#
# An example hook script to prepare a packed repository for use over
# dumb transports.
#
# To enable this hook, rename this file to "post-update".
exec git update-server-info
#!/bin/sh
#
# An example hook script to verify what is about to be committed
# by applypatch from an e-mail message.
#
# The hook should exit with non-zero status after issuing an
# appropriate message if it wants to stop the commit.
#
# To enable this hook, rename this file to "pre-applypatch".
. git-sh-setup
precommit="$(git rev-parse --git-path hooks/pre-commit)"
test -x "$precommit" && exec "$precommit" ${1+"[email protected]"}
:
#!/bin/sh
#
# An example hook script to verify what is about to be committed.
# Called by "git commit" with no arguments. The hook should
# exit with non-zero status after issuing an appropriate message if
# it wants to stop the commit.
#
# To enable this hook, rename this file to "pre-commit".
if git rev-parse --verify HEAD >/dev/null 2>&1
then
against=HEAD
else
# Initial commit: diff against an empty tree object
against=4b825dc642cb6eb9a060e54bf8d69288fbee4904
fi
# If you want to allow non-ASCII filenames set this variable to true.
allownonascii=$(git config --bool hooks.allownonascii)
# Redirect output to stderr.
exec 1>&2
# Cross platform projects tend to avoid non-ASCII filenames; prevent
# them from being added to the repository. We exploit the fact that the
# printable range starts at the space character and ends with tilde.
if [ "$allownonascii" != "true" ] &&
# Note that the use of brackets around a tr range is ok here, (it's
# even required, for portability to Solaris 10's /usr/bin/tr), since
# the square bracket bytes happen to fall in the designated range.
test $(git diff --cached --name-only --diff-filter=A -z $against |
LC_ALL=C tr -d '[ -~]\0' | wc -c) != 0
then
cat <<\EOF
Error: Attempt to add a non-ASCII file name.
This can cause problems if you want to work with people on other platforms.
To be portable it is advisable to rename the file.
If you know what you are doing you can disable this check using:
git config hooks.allownonascii true
EOF
exit 1
fi
# If there are whitespace errors, print the offending file names and fail.
exec git diff-index --check --cached $against --
#!/bin/sh
# An example hook script to verify what is about to be pushed. Called by "git
# push" after it has checked the remote status, but before anything has been
# pushed. If this script exits with a non-zero status nothing will be pushed.
#
# This hook is called with the following parameters:
#
# $1 -- Name of the remote to which the push is being done
# $2 -- URL to which the push is being done
#
# If pushing without using a named remote those arguments will be equal.
#
# Information about the commits which are being pushed is supplied as lines to
# the standard input in the form:
#
# <local ref> <local sha1> <remote ref> <remote sha1>
#
# This sample shows how to prevent push of commits where the log message starts
# with "WIP" (work in progress).
remote="$1"
url="$2"
z40=0000000000000000000000000000000000000000
while read local_ref local_sha remote_ref remote_sha
do
if [ "$local_sha" = $z40 ]
then
# Handle delete
:
else
if [ "$remote_sha" = $z40 ]
then
# New branch, examine all commits
range="$local_sha"
else
# Update to existing branch, examine new commits
range="$remote_sha..$local_sha"
fi
# Check for WIP commit
commit=`git rev-list -n 1 --grep '^WIP' "$range"`
if [ -n "$commit" ]
then
echo >&2 "Found WIP commit in $local_ref, not pushing"
exit 1
fi
fi
done
exit 0
#!/bin/sh
#
# Copyright (c) 2006, 2008 Junio C Hamano
#
# The "pre-rebase" hook is run just before "git rebase" starts doing
# its job, and can prevent the command from running by exiting with
# non-zero status.
#
# The hook is called with the following parameters:
#
# $1 -- the upstream the series was forked from.
# $2 -- the branch being rebased (or empty when rebasing the current branch).
#
# This sample shows how to prevent topic branches that are already
# merged to 'next' branch from getting rebased, because allowing it
# would result in rebasing already published history.
publish=next
basebranch="$1"
if test "$#" = 2
then
topic="refs/heads/$2"
else
topic=`git symbolic-ref HEAD` ||
exit 0 ;# we do not interrupt rebasing detached HEAD
fi
case "$topic" in
refs/heads/??/*)
;;
*)
exit 0 ;# we do not interrupt others.
;;
esac
# Now we are dealing with a topic branch being rebased
# on top of master. Is it OK to rebase it?
# Does the topic really exist?
git show-ref -q "$topic" || {
echo >&2 "No such branch $topic"
exit 1
}
# Is topic fully merged to master?
not_in_master=`git rev-list --pretty=oneline ^master "$topic"`
if test -z "$not_in_master"
then
echo >&2 "$topic is fully merged to master; better remove it."
exit 1 ;# we could allow it, but there is no point.
fi
# Is topic ever merged to next? If so you should not be rebasing it.
only_next_1=`git rev-list ^master "^$topic" ${publish} | sort`
only_next_2=`git rev-list ^master ${publish} | sort`
if test "$only_next_1" = "$only_next_2"
then
not_in_topic=`git rev-list "^$topic" master`
if test -z "$not_in_topic"
then
echo >&2 "$topic is already up-to-date with master"
exit 1 ;# we could allow it, but there is no point.
else
exit 0
fi
else
not_in_next=`git rev-list --pretty=oneline ^${publish} "$topic"`
/usr/bin/perl -e '
my $topic = $ARGV[0];
my $msg = "* $topic has commits already merged to public branch:\n";
my (%not_in_next) = map {
/^([0-9a-f]+) /;
($1 => 1);
} split(/\n/, $ARGV[1]);
for my $elem (map {
/^([0-9a-f]+) (.*)$/;
[$1 => $2];
} split(/\n/, $ARGV[2])) {
if (!exists $not_in_next{$elem->[0]}) {
if ($msg) {
print STDERR $msg;
undef $msg;
}
print STDERR " $elem->[1]\n";
}
}
' "$topic" "$not_in_next" "$not_in_master"
exit 1
fi
exit 0
################################################################
This sample hook safeguards topic branches that have been
published from being rewound.
The workflow assumed here is:
* Once a topic branch forks from "master", "master" is never
merged into it again (either directly or indirectly).
* Once a topic branch is fully cooked and merged into "master",
it is deleted. If you need to build on top of it to correct
earlier mistakes, a new topic branch is created by forking at
the tip of the "master". This is not strictly necessary, but
it makes it easier to keep your history simple.
* Whenever you need to test or publish your changes to topic
branches, merge them into "next" branch.
The script, being an example, hardcodes the publish branch name
to be "next", but it is trivial to make it configurable via
$GIT_DIR/config mechanism.
With this workflow, you would want to know:
(1) ... if a topic branch has ever been merged to "next". Young
topic branches can have stupid mistakes you would rather
clean up before publishing, and things that have not been
merged into other branches can be easily rebased without
affecting other people. But once it is published, you would
not want to rewind it.
(2) ... if a topic branch has been fully merged to "master".
Then you can delete it. More importantly, you should not
build on top of it -- other people may already want to
change things related to the topic as patches against your
"master", so if you need further changes, it is better to
fork the topic (perhaps with the same name) afresh from the
tip of "master".
Let's look at this example:
o---o---o---o---o---o---o---o---o---o "next"
/ / / /
/ a---a---b A / /
/ / / /
/ / c---c---c---c B /
/ / / \ /
/ / / b---b C \ /
/ / / / \ /
---o---o---o---o---o---o---o---o---o---o---o "master"
A, B and C are topic branches.
* A has one fix since it was merged up to "next".
* B has finished. It has been fully merged up to "master" and "next",
and is ready to be deleted.
* C has not merged to "next" at all.
We would want to allow C to be rebased, refuse A, and encourage
B to be deleted.
To compute (1):
git rev-list ^master ^topic next
git rev-list ^master next
if these match, topic has not merged in next at all.
To compute (2):
git rev-list master..topic
if this is empty, it is fully merged to "master".
#!/bin/bash
if test -n "$GIT_PUSH_OPTION_COUNT"
then
i=0
while test "$i" -lt "$GIT_PUSH_OPTION_COUNT"
do
eval "value=\$GIT_PUSH_OPTION_$i"